#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Yellow
#property indicator_color2 Yellow
#property indicator_color3 Black
#property indicator_color4 Black
#property indicator_color5 Blue
#property indicator_color6 Blue
#property indicator_color7 Red
#property indicator_color8 Red

double g_ibuf_76[];
double g_ibuf_80[];
double gda_84[];
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
double g_ibuf_104[];
int gi_108;

int init() {
   SetIndexStyle(0, DRAW_ARROW, STYLE_DOT, 1, Yellow);
   SetIndexDrawBegin(0, gi_108 - 1);
   SetIndexBuffer(0, g_ibuf_76);
   SetIndexLabel(0, "Resistance M15");
   SetIndexArrow(0, 158);
   SetIndexStyle(1, DRAW_ARROW, STYLE_DOT, 1, Yellow);
   SetIndexDrawBegin(1, gi_108 - 1);
   SetIndexBuffer(1, g_ibuf_80);
   SetIndexLabel(1, "Support M15");
   SetIndexArrow(1, 158);
   SetIndexBuffer(3, g_ibuf_88);
   SetIndexLabel(3, "Support H1");
   SetIndexArrow(3, 158);
   SetIndexStyle(4, DRAW_ARROW, STYLE_DOT, 1, Blue);
   SetIndexDrawBegin(4, gi_108 - 1);
   SetIndexBuffer(4, g_ibuf_92);
   SetIndexLabel(4, "Resistance H4");
   SetIndexArrow(4, 158);
   SetIndexStyle(5, DRAW_ARROW, STYLE_DOT, 1, Blue);
   SetIndexDrawBegin(5, gi_108 - 1);
   SetIndexBuffer(5, g_ibuf_96);
   SetIndexLabel(5, "Support H4");
   SetIndexArrow(5, 158);
   SetIndexStyle(6, DRAW_ARROW, STYLE_DOT, 1, Red);
   SetIndexDrawBegin(6, gi_108 - 1);
   SetIndexBuffer(6, g_ibuf_100);
   SetIndexLabel(6, "Resistance D1");
   SetIndexArrow(6, 158);
   SetIndexStyle(7, DRAW_ARROW, STYLE_DOT, 1, Red);
   SetIndexDrawBegin(7, gi_108 - 1);
   SetIndexBuffer(7, g_ibuf_104);
   SetIndexLabel(7, "Support D1");
   SetIndexArrow(7, 158);
   return (0);
}

int deinit() {
   return (0);
}

int Fractal(string as_0, int ai_8, int ai_12) {
   if (Period() > ai_8) return (-1);
   ai_8 = ai_8 / Period() * 2 + MathCeil(ai_8 / Period() / 2);
   if (ai_12 < ai_8) return (-1);
   if (ai_12 > Bars - ai_8) return (-1);
   for (int li_16 = 1; li_16 <= ai_8; li_16++) {
      if (as_0 == "U") {
         if (High[ai_12 + li_16] > High[ai_12]) return (-1);
         if (High[ai_12 - li_16] >= High[ai_12]) return (-1);
      }
      if (as_0 == "L") {
         if (Low[ai_12 + li_16] < Low[ai_12]) return (-1);
         if (Low[ai_12 - li_16] <= Low[ai_12]) return (-1);
      }
   }
   return (1);
}

int start() {
   int li_0 = 1440;
   int li_4 = 240;
   int li_8 = 60;
   int li_12 = 15;
   for (gi_108 = Bars; gi_108 >= 0; gi_108--) {
      if (Fractal("U", li_12, gi_108) == 1) g_ibuf_76[gi_108] = High[gi_108];
      else g_ibuf_76[gi_108] = g_ibuf_76[gi_108 + 1];
      if (Fractal("L", li_12, gi_108) == 1) g_ibuf_80[gi_108] = Low[gi_108];
      else g_ibuf_80[gi_108] = g_ibuf_80[gi_108 + 1];
      if (Fractal("U", li_8, gi_108) == 1) gda_84[gi_108] = High[gi_108];
      else gda_84[gi_108] = gda_84[gi_108 + 1];
      if (Fractal("L", li_8, gi_108) == 1) g_ibuf_88[gi_108] = Low[gi_108];
      else g_ibuf_88[gi_108] = g_ibuf_88[gi_108 + 1];
      if (Fractal("U", li_4, gi_108) == 1) g_ibuf_92[gi_108] = High[gi_108];
      else g_ibuf_92[gi_108] = g_ibuf_92[gi_108 + 1];
      if (Fractal("L", li_4, gi_108) == 1) g_ibuf_96[gi_108] = Low[gi_108];
      else g_ibuf_96[gi_108] = g_ibuf_96[gi_108 + 1];
      if (Fractal("U", li_0, gi_108) == 1) g_ibuf_100[gi_108] = High[gi_108];
      else g_ibuf_100[gi_108] = g_ibuf_100[gi_108 + 1];
      if (Fractal("L", li_0, gi_108) == 1) g_ibuf_104[gi_108] = Low[gi_108];
      else g_ibuf_104[gi_108] = g_ibuf_104[gi_108 + 1];
   }
   return (0);
}