
#property copyright "Copyright  2008"
#property link      "www.freedom.net"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Lime
#property indicator_color2 Lime
#property indicator_color3 Lime
#property indicator_color4 Lime
#property indicator_color5 Lime
#property indicator_color6 Lime
#property indicator_color7 Lime
#property indicator_color8 Lime

double g_ibuf_76[];
double g_ibuf_80[];
double g_ibuf_84[];
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
double g_ibuf_104[];
extern int myPeriod = 1440;
extern double SD_1 = 1.0;
extern double SD_2 = 2.0;
extern double SD_3 = 3.0;
extern double SD_4 = 4.0;
double gd_144;
double gd_152;
double gd_160;
double gd_168;
double gd_176;
double gd_184;
double gd_192;
double gd_200;
double gd_208;

int init() {
   SetIndexBuffer(0, g_ibuf_76);
   SetIndexBuffer(1, g_ibuf_80);
   SetIndexBuffer(2, g_ibuf_84);
   SetIndexBuffer(3, g_ibuf_88);
   SetIndexBuffer(4, g_ibuf_92);
   SetIndexBuffer(5, g_ibuf_96);
   SetIndexBuffer(6, g_ibuf_100);
   SetIndexBuffer(7, g_ibuf_104);
   SetIndexStyle(0, DRAW_LINE, STYLE_DOT);
   SetIndexStyle(1, DRAW_LINE, STYLE_DOT);
   SetIndexStyle(2, DRAW_LINE, STYLE_DOT);
   SetIndexStyle(3, DRAW_LINE, STYLE_DOT);
   SetIndexStyle(4, DRAW_LINE, STYLE_DOT);
   SetIndexStyle(5, DRAW_LINE, STYLE_DOT);
   SetIndexStyle(6, DRAW_LINE, STYLE_DOT);
   SetIndexStyle(7, DRAW_LINE, STYLE_DOT);
   return (0);
}

int deinit() {
   ObjectDelete("HSD_0.5");
   ObjectDelete("HSD_1.0");
   ObjectDelete("HSD_1.5");
   ObjectDelete("HSD_2.0");
   ObjectDelete("LSD_0.5");
   ObjectDelete("LSD_1.0");
   ObjectDelete("LSD_1.5");
   ObjectDelete("LSD_2.0");
   ObjectDelete("txtLSD_0.5");
   ObjectDelete("txtLSD_1.0");
   ObjectDelete("txtLSD_1.5");
   ObjectDelete("txtLSD_2.0");
   ObjectDelete("txtHSD_0.5");
   ObjectDelete("txtHSD_1.0");
   ObjectDelete("txtHSD_1.5");
   ObjectDelete("txtHSD_2.0");
   Comment("Kg Standard Deviation Level");
   return (0);
}

int start() {
   int l_shift_4;
   double l_ilow_12;
   double l_ihigh_20;
   double l_iopen_28;
   double l_iclose_36;
   double ld_44;
   double ld_52;
   double ld_60;
   double ld_68;
   double ld_76;
   double ld_84;
   int li_8 = IndicatorCounted();
   if (li_8 < 0) return (-1);
   if (li_8 > 0) li_8--;
   int li_92 = Bars - li_8;
   for (int li_0 = li_92 - 1; li_0 >= 0; li_0--) {
      l_shift_4 = iBarShift(Symbol(), myPeriod, Time[li_0], FALSE);
      gd_208 = iHigh(Symbol(), myPeriod, l_shift_4 + 1) - iLow(Symbol(), myPeriod, l_shift_4 + 1);
      l_ilow_12 = iLow(NULL, myPeriod, l_shift_4 + 1);
      l_ihigh_20 = iHigh(NULL, myPeriod, l_shift_4 + 1);
      l_iopen_28 = iOpen(NULL, myPeriod, l_shift_4 + 1);
      l_iclose_36 = iClose(NULL, myPeriod, l_shift_4 + 1);
      ld_44 = MathPow(l_iclose_36 - (2.0 * l_iclose_36 + l_ilow_12 + l_ihigh_20) / 4.0, 2) + MathPow(l_iclose_36 - (2.0 * l_iclose_36 + l_ilow_12 + l_ihigh_20) / 4.0, 2) + MathPow(l_ilow_12 - (2.0 * l_iclose_36 + l_ilow_12 + l_ihigh_20) / 4.0, 2) + MathPow(l_ihigh_20 - (2.0 * l_iclose_36 + l_ilow_12 + l_ihigh_20) / 4.0, 2);
      ld_76 = SD_4 * MathSqrt(ld_44 / 3.0);
      ld_68 = SD_3 * MathSqrt(ld_44 / 3.0);
      ld_60 = SD_2 * MathSqrt(ld_44 / 3.0);
      ld_52 = SD_1 * MathSqrt(ld_44 / 3.0);
      ld_84 = (2.0 * l_iclose_36 + l_ilow_12 + l_ihigh_20) / 4.0;
      gd_144 = ld_84 + ld_52;
      gd_152 = ld_84 - ld_52;
      gd_160 = ld_84 + ld_60;
      gd_168 = ld_84 - ld_60;
      gd_176 = ld_84 + ld_68;
      gd_184 = ld_84 - ld_68;
      gd_192 = ld_84 + ld_76;
      gd_200 = ld_84 - ld_76;
      g_ibuf_76[li_0] = gd_144;
      SetPrice("HSD_0.5", Time[li_0], gd_144, Lime);
      SetText("txtHSD_0.5", DoubleToStr(SD_1, 1), Time[li_0], gd_144, Lime);
      g_ibuf_80[li_0] = gd_152;
      SetPrice("LSD_0.5", Time[li_0], gd_152, Lime);
      SetText("txtLSD_0.5", DoubleToStr(SD_1, 1), Time[li_0], gd_152, Lime);
      g_ibuf_84[li_0] = gd_160;
      SetPrice("HSD_1.0", Time[li_0], gd_160, Lime);
      SetText("txtHSD_1.0", DoubleToStr(SD_2, 1), Time[li_0], gd_160, Lime);
      g_ibuf_88[li_0] = gd_168;
      SetPrice("LSD_1.0", Time[li_0], gd_168, Lime);
      SetText("txtLSD_1.0", DoubleToStr(SD_2, 1), Time[li_0], gd_168, Lime);
      g_ibuf_92[li_0] = gd_176;
      SetPrice("HSD_1.5", Time[li_0], gd_176, Lime);
      SetText("txtHSD_1.5", DoubleToStr(SD_3, 1), Time[li_0], gd_176, Lime);
      g_ibuf_96[li_0] = gd_184;
      SetPrice("LSD_1.5", Time[li_0], gd_184, Lime);
      SetText("txtLSD_1.5", DoubleToStr(SD_3, 1), Time[li_0], gd_184, Lime);
      g_ibuf_100[li_0] = gd_192;
      SetPrice("HSD_2.0", Time[li_0], gd_192, Lime);
      SetText("txtHSD_2.0", DoubleToStr(SD_4, 1), Time[li_0], gd_192, Lime);
      g_ibuf_104[li_0] = gd_200;
      SetPrice("LSD_2.0", Time[li_0], gd_200, Lime);
      SetText("txtLSD_2.0", DoubleToStr(SD_4, 1), Time[li_0], gd_200, Lime);
   }
   return (0);
}

void SetPrice(string a_name_0, int a_datetime_8, double a_price_12, color a_color_20) {
   if (ObjectFind(a_name_0) == -1) {
      ObjectCreate(a_name_0, OBJ_ARROW, 0, a_datetime_8, a_price_12);
      ObjectSet(a_name_0, OBJPROP_COLOR, a_color_20);
      ObjectSet(a_name_0, OBJPROP_WIDTH, 1);
      ObjectSet(a_name_0, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
      return;
   }
   ObjectSet(a_name_0, OBJPROP_TIME1, a_datetime_8);
   ObjectSet(a_name_0, OBJPROP_PRICE1, a_price_12);
   ObjectSet(a_name_0, OBJPROP_COLOR, a_color_20);
   ObjectSet(a_name_0, OBJPROP_WIDTH, 1);
   ObjectSet(a_name_0, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
}

void SetText(string a_name_0, string a_text_8, int a_datetime_16, double a_price_20, color a_color_28) {
   if (ObjectFind(a_name_0) == -1) {
      ObjectCreate(a_name_0, OBJ_TEXT, 0, a_datetime_16, a_price_20);
      ObjectSetText(a_name_0, a_text_8, 7, "Times New Roman", a_color_28);
      return;
   }
   ObjectSet(a_name_0, OBJPROP_TIME1, a_datetime_16);
   ObjectSet(a_name_0, OBJPROP_PRICE1, a_price_20);
   ObjectSetText(a_name_0, a_text_8, 7, "Times New Roman", a_color_28);
}